from abc import Singleton
import RPi.GPIO as GPIO
import spidev


class LowLevel(metaclass=Singleton)
    def __init__(self):
        self.__spi = spidev.SpiDev()
        self.__spi.open(0,0)
        self.__spi.mode = 0
        self.__spi.max_speed_hz = 1000000
        GPIO.setmode(GPIO.BCM)                               


    def __activate(self):
        self.__spi.cshigh = False

    def __deactivate(self):
        self.__spi.cshigh = True

    def retrieve_adc(self, channel):
        if channel > 7 or channel < 0:                   
            return None

        GPIO.output(pin, True)     
        hchbit=channel >> 2                              
        lchbits = channel & 0x03                         
        to_send = [ hchbit | 0x06, lchbits << 6, 0x00 ]  
        self.__activate()
        r=spi.xfer(to_send)                              
        self.__deactivate()
        GPIO.output(pin, False)    
        highbyte = r[1]                                  
        lowbyte = r[2]                                   
        value = (highbyte << 8) | lowbyte                
        return value
